package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.EscolaDAO;
import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Escola;
import com.rjconsultores.ventaboletos.service.EscolaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("escolaService")
public class EscolaServiceImpl implements EscolaService {

	@Autowired
	private EscolaDAO EscolaDAO;
	public List<Escola> obtenerTodos() {
		return EscolaDAO.obtenerTodos();
	}

	public Escola obtenerID(Integer id) {
		return EscolaDAO.obtenerID(id);
	}

	@Transactional
	public Escola suscribir(Escola entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return EscolaDAO.suscribir(entidad);
	}

	@Transactional
	public Escola actualizacion(Escola entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return EscolaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(Escola entidad) throws RegistroConDependenciaException {

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		EscolaDAO.actualizacion(entidad);
	}

	public List<Escola> buscar(String nombEscola, Ciudad ciudad) {
		return EscolaDAO.buscar(nombEscola, ciudad);
	}
}
